defmodule ElixirLibxl.MixProject do
  use Mix.Project

  def project do
    [
      app: :elixir_libxl,
      version: "0.2.0",
      elixir: "~> 1.13",
      start_permanent: Mix.env() == :prod,
      deps: deps(),
      compilers: [:elixir_make | Mix.compilers()],
      make_clean: ["clean"],
      name: "ElixirLibxl",
      package: package(),
      description: description(),
      source_url: "https://bitbucket.org/senanetworksinc/elixir_libxl"
    ]
  end

  # Run "mix help compile.app" to learn about applications.
  def application do
    [
      extra_applications: [:logger]
    ]
  end

  # Run "mix help deps" to learn about dependencies.
  defp deps do
    [
      {:elixir_make, "~> 0.6", runtime: false},
      {:mix_test_watch, "0.6.0", [only: :dev, runtime: false]},
      {:ex_doc, "~> 0.14", only: :dev, runtime: false}
    ]
  end

  defp description() do
    "[LibXL](https://www.libxl.com/) elixir port"
  end

  defp package() do
    [
      name: "elixir_libxl",
      files: ~w(lib priv .formatter.exs mix.exs README.md c_src Makefile test),
      licenses: ["MIT"],
      links: %{"Bitbucket" => "https://bitbucket.org/senanetworksinc/elixir_libxl"}
    ]
  end
end
