defmodule AutofilterTest do
	use ExUnit.Case
	doctest ElixirLibxl

	test "autofilter" do
		book_handle = ElixirLibxl.xlCreateXMLBook()

		sheet_handle = ElixirLibxl.xlBookAddSheet(book_handle, "test sheet", nil)

		autofilter_handle = ElixirLibxl.xlSheetAutoFilter(sheet_handle)

		ElixirLibxl.xlAutoFilterSetRef(autofilter_handle, 0, 1, 2, 3)

		assert ElixirLibxl.xlAutoFilterGetRef(autofilter_handle) == [1, 0, 1, 2, 3]

		assert ElixirLibxl.xlAutoFilterColumn(autofilter_handle, 0) != nil

		assert ElixirLibxl.xlAutoFilterColumnSize(autofilter_handle) == 1

		assert ElixirLibxl.xlAutoFilterColumnByIndex(autofilter_handle, 0) != nil

		assert ElixirLibxl.xlAutoFilterSetSort(autofilter_handle, 0, 0) == 1

		assert ElixirLibxl.xlAutoFilterAddSort(autofilter_handle, 0, 0) == 1

		assert ElixirLibxl.xlAutoFilterGetSortRange(autofilter_handle) == [1, 1, 1, 2, 3]

		assert ElixirLibxl.xlAutoFilterGetSort(autofilter_handle) == [1, 0, 0]

		ElixirLibxl.xlBookRelease(book_handle)
	end
end
