defmodule FilterColumnTest do
	use ExUnit.Case
	doctest ElixirLibxl

	test "filter_column" do
		book_handle = ElixirLibxl.xlCreateXMLBook()

		sheet_handle = ElixirLibxl.xlBookAddSheet(book_handle, "test sheet", nil)

		autofilter_handle = ElixirLibxl.xlSheetAutoFilter(sheet_handle)

		ElixirLibxl.xlAutoFilterSetRef(autofilter_handle, 0, 1, 2, 3)

		filter_colum_handle = ElixirLibxl.xlAutoFilterColumn(autofilter_handle, 0)

		assert ElixirLibxl.xlFilterColumnIndex(filter_colum_handle) == 0

		assert ElixirLibxl.xlFilterColumnFilterType(filter_colum_handle) == 7

		assert ElixirLibxl.xlFilterColumnFilterSize(filter_colum_handle) == 0

		ElixirLibxl.xlFilterColumnAddFilter(filter_colum_handle, "filter")

		assert ElixirLibxl.xlFilterColumnFilter(filter_colum_handle, 0) == "filter"

		ElixirLibxl.xlFilterColumnSetTop10(filter_colum_handle, 1.0, 2, 3)

		assert ElixirLibxl.xlFilterColumnGetTop10(filter_colum_handle) == [1, 1.0, 1, 1]

		ElixirLibxl.xlFilterColumnSetCustomFilter(filter_colum_handle, 1, "test")

		assert ElixirLibxl.xlFilterColumnGetCustomFilter(filter_colum_handle) == [1, 1, "test", 0, "", 0]

		ElixirLibxl.xlFilterColumnSetCustomFilterEx(filter_colum_handle, 1, "test1", 2, "test2", 3)

		assert ElixirLibxl.xlFilterColumnGetCustomFilter(filter_colum_handle) == [1, 1, "test", 2, "", 1]

		ElixirLibxl.xlFilterColumnClear(filter_colum_handle)

		ElixirLibxl.xlBookRelease(book_handle)
	end
end
