defmodule FontTest do
	use ExUnit.Case
	doctest ElixirLibxl

	test "font" do
		book_handle = ElixirLibxl.xlCreateXMLBook()

		sheet_handle = ElixirLibxl.xlBookAddSheet(book_handle, "test sheet", nil)

		format_handle = ElixirLibxl.xlSheetCellFormat(sheet_handle, 0, 0)

		font_handle = ElixirLibxl.xlFormatFont(format_handle)

		ElixirLibxl.xlFontSetSize(font_handle, 1)

		assert ElixirLibxl.xlFontSize(font_handle) == 1

		ElixirLibxl.xlFontSetItalic(font_handle, 1)

		assert ElixirLibxl.xlFontItalic(font_handle) == 1

		ElixirLibxl.xlFontSetStrikeOut(font_handle, 1)

		assert ElixirLibxl.xlFontStrikeOut(font_handle) == 1

		ElixirLibxl.xlFontSetColor(font_handle, 1)

		assert ElixirLibxl.xlFontColor(font_handle) == 1

		ElixirLibxl.xlFontSetBold(font_handle, 1)

		assert ElixirLibxl.xlFontBold(font_handle) == 1

		ElixirLibxl.xlFontSetScript(font_handle, 1)

		assert ElixirLibxl.xlFontScript(font_handle) == 1

		ElixirLibxl.xlFontSetUnderline(font_handle, 1)

		assert ElixirLibxl.xlFontUnderline(font_handle) == 1

		ElixirLibxl.xlFontSetName(font_handle, "test")

		assert ElixirLibxl.xlFontName(font_handle) == "test"

		ElixirLibxl.xlBookRelease(book_handle)
	end
end
