defmodule FormControlTest do
	use ExUnit.Case
	doctest ElixirLibxl

	test "form_control" do
		book_handle = ElixirLibxl.xlCreateXMLBook()

		assert ElixirLibxl.xlBookLoad(book_handle, Application.app_dir(:elixir_libxl, "priv/test") <> "/Book1.xlsx") > 0

		sheet_handle = ElixirLibxl.xlBookGetSheet(book_handle, 0)

		form_control_handle = ElixirLibxl.xlSheetFormControl(sheet_handle, 0)

		assert ElixirLibxl.xlSheetFormControlSize(sheet_handle) > 0

		assert ElixirLibxl.xlFormControlObjectType(form_control_handle) == 1

		assert ElixirLibxl.xlFormControlChecked(form_control_handle) == 0

		ElixirLibxl.xlFormControlSetChecked(form_control_handle, 0)

		assert ElixirLibxl.xlFormControlFmlaGroup(form_control_handle) == ""

		ElixirLibxl.xlFormControlSetFmlaGroup(form_control_handle, "test")

		assert ElixirLibxl.xlFormControlFmlaLink(form_control_handle) == ""

		ElixirLibxl.xlFormControlSetFmlaLink(form_control_handle, "test")

		ElixirLibxl.xlFormControlSetFmlaRange(form_control_handle, "test")

		assert ElixirLibxl.xlFormControlFmlaRange(form_control_handle) == "test"

		ElixirLibxl.xlFormControlSetFmlaTxbx(form_control_handle, "test")

		assert ElixirLibxl.xlFormControlFmlaTxbx(form_control_handle) == "test"

		assert ElixirLibxl.xlFormControlName(form_control_handle) == "Button 1"

		assert ElixirLibxl.xlFormControlLinkedCell(form_control_handle) == ""

		assert ElixirLibxl.xlFormControlListFillRange(form_control_handle) == ""

		assert ElixirLibxl.xlFormControlMacro(form_control_handle) == "[0]!ボタン1_Click"

		assert ElixirLibxl.xlFormControlAltText(form_control_handle) == ""

		assert ElixirLibxl.xlFormControlLocked(form_control_handle) == 1

		assert ElixirLibxl.xlFormControlDefaultSize(form_control_handle) == 0

		assert ElixirLibxl.xlFormControlPrint(form_control_handle) == 0

		assert ElixirLibxl.xlFormControlDisabled(form_control_handle) == 0

		assert ElixirLibxl.xlFormControlItem(form_control_handle, 0) == :error

		assert ElixirLibxl.xlFormControlItemSize(form_control_handle) == 0

		ElixirLibxl.xlFormControlAddItem(form_control_handle, "test")

		ElixirLibxl.xlFormControlInsertItem(form_control_handle, 0, "test")

		ElixirLibxl.xlFormControlClearItems(form_control_handle)

		assert ElixirLibxl.xlFormControlDropLines(form_control_handle) == 8

		ElixirLibxl.xlFormControlSetDropLines(form_control_handle, 1)

		assert ElixirLibxl.xlFormControlDx(form_control_handle) == 80

		ElixirLibxl.xlFormControlSetDx(form_control_handle, 1)

		assert ElixirLibxl.xlFormControlFirstButton(form_control_handle) == 0

		ElixirLibxl.xlFormControlSetFirstButton(form_control_handle, 1)

		assert ElixirLibxl.xlFormControlHoriz(form_control_handle) == 0

		ElixirLibxl.xlFormControlSetHoriz(form_control_handle, 1)

		assert ElixirLibxl.xlFormControlInc(form_control_handle) == 1

		ElixirLibxl.xlFormControlSetInc(form_control_handle, 1)

		assert ElixirLibxl.xlFormControlGetMax(form_control_handle) == 0

		ElixirLibxl.xlFormControlSetMax(form_control_handle, 1)

		assert ElixirLibxl.xlFormControlGetMin(form_control_handle) == 0

		ElixirLibxl.xlFormControlSetMin(form_control_handle, 1)

		assert ElixirLibxl.xlFormControlMultiSel(form_control_handle) == ""

		ElixirLibxl.xlFormControlSetMultiSel(form_control_handle, "test")

		assert ElixirLibxl.xlFormControlSel(form_control_handle) == 0

		ElixirLibxl.xlFormControlSetSel(form_control_handle, 1)

		assert ElixirLibxl.xlFormControlFromAnchor(form_control_handle) == [1, 1, 520700, 3, 114300]

		assert ElixirLibxl.xlFormControlToAnchor(form_control_handle) == [1, 3, 139700, 4, 241300]

		ElixirLibxl.xlBookRelease(book_handle)
	end
end
