defmodule FormatTest do
	use ExUnit.Case
	doctest ElixirLibxl

	test "format" do
		book_handle = ElixirLibxl.xlCreateXMLBook()

		sheet_handle = ElixirLibxl.xlBookAddSheet(book_handle, "test sheet", nil)

		format_handle = ElixirLibxl.xlSheetCellFormat(sheet_handle, 0, 0)

		font_handle = ElixirLibxl.xlFormatFont(format_handle)

		assert ElixirLibxl.xlFormatSetFont(format_handle, font_handle) == 1

		ElixirLibxl.xlFormatSetNumFormat(format_handle, 123)

		assert ElixirLibxl.xlFormatNumFormat(format_handle) == 123

		ElixirLibxl.xlFormatSetAlignH(format_handle, 1)

		assert ElixirLibxl.xlFormatAlignH(format_handle) == 1

		ElixirLibxl.xlFormatSetAlignV(format_handle, 1)

		assert ElixirLibxl.xlFormatAlignV(format_handle) == 1

		ElixirLibxl.xlFormatSetWrap(format_handle, 1)

		assert ElixirLibxl.xlFormatWrap(format_handle) == 1

		ElixirLibxl.xlFormatSetRotation(format_handle, 1)

		assert ElixirLibxl.xlFormatRotation(format_handle) == 1

		ElixirLibxl.xlFormatSetIndent(format_handle, 1)

		assert ElixirLibxl.xlFormatIndent(format_handle) == 1

		ElixirLibxl.xlFormatSetShrinkToFit(format_handle, 1)

		assert ElixirLibxl.xlFormatShrinkToFit(format_handle) == 1

		ElixirLibxl.xlFormatSetBorder(format_handle, 1)

		ElixirLibxl.xlFormatSetBorderColor(format_handle, 1)

		ElixirLibxl.xlFormatSetBorderLeft(format_handle, 1)

		ElixirLibxl.xlFormatSetBorderRight(format_handle, 1)

		ElixirLibxl.xlFormatBorderTop(format_handle)

		ElixirLibxl.xlFormatSetBorderTop(format_handle, 1)

		ElixirLibxl.xlFormatSetBorderBottom(format_handle, 1)

		ElixirLibxl.xlFormatSetBorderLeftColor(format_handle, 1)

		ElixirLibxl.xlFormatSetBorderRightColor(format_handle, 1)

		ElixirLibxl.xlFormatSetBorderTopColor(format_handle, 1)

		ElixirLibxl.xlFormatSetBorderBottomColor(format_handle, 1)

		assert ElixirLibxl.xlFormatBorderLeft(format_handle) == 1

		assert ElixirLibxl.xlFormatBorderBottom(format_handle) == 1

		assert ElixirLibxl.xlFormatBorderRight(format_handle) == 1

		assert ElixirLibxl.xlFormatBorderLeftColor(format_handle) == 1

		assert ElixirLibxl.xlFormatBorderRightColor(format_handle) == 1

		assert ElixirLibxl.xlFormatBorderTopColor(format_handle) == 1

		assert ElixirLibxl.xlFormatBorderBottomColor(format_handle) == 1

		ElixirLibxl.xlFormatSetBorderDiagonal(format_handle, 1)

		assert ElixirLibxl.xlFormatBorderDiagonal(format_handle) == 1

		ElixirLibxl.xlFormatSetBorderDiagonalStyle(format_handle, 1)

		ElixirLibxl.xlFormatSetBorderDiagonalColor(format_handle, 1)

		ElixirLibxl.xlFormatSetFillPattern(format_handle, 1)

		ElixirLibxl.xlFormatSetPatternForegroundColor(format_handle, 1)

		ElixirLibxl.xlFormatSetPatternBackgroundColor(format_handle, 65)

		ElixirLibxl.xlFormatSetLocked(format_handle, 1)

		ElixirLibxl.xlFormatSetHidden(format_handle, 1)

		assert ElixirLibxl.xlFormatHidden(format_handle) == 1

		assert ElixirLibxl.xlFormatLocked(format_handle) == 1

		assert ElixirLibxl.xlFormatPatternBackgroundColor(format_handle) == 65

		assert ElixirLibxl.xlFormatPatternForegroundColor(format_handle) == 1

		assert ElixirLibxl.xlFormatBorderDiagonalStyle(format_handle) == 1

		assert ElixirLibxl.xlFormatBorderDiagonalColor(format_handle) == 1

		assert ElixirLibxl.xlFormatFillPattern(format_handle) == 1

		ElixirLibxl.xlBookRelease(book_handle)
	end
end
